close all
warning('off')
clearvars
clc
m=50; % Number of samples
SNR= 25; % SNR level
doPlot = 1; 

%%

f0=1/7+.157*rand; % Simulate fundamental frequency
K= floor(1/f0); % Number of peaks
d=random('unif',0,2*pi,K,1); % Get phase
ap=(ones(K,1)+.3*randn(K,1)).*exp(1i*d); % Amplitude


f0 = [f0*(1:K)']; % Frequencies 
smp=(1:m); y_true=exp(-2i*pi*(1:m)'*f0')*ap;
y=exp(-2i*pi*(smp-1)'*f0')*ap;
sigma2 = norm(y).^2/length(y)*(10^(SNR/10))^-1;
noise_t = sqrt(sigma2)/sqrt(2)*randn(m,1) + 1i*sqrt(sigma2)/sqrt(2)*randn(m,1);
y = y + noise_t(smp,:);
%% ---------------------------------------Proposed method

tic
[fesB,xesB,G]=BSURE(y,smp-1,doPlot);
timeB =  toc
G
%%
figure
stem(fesB,abs(xesB))
hold on
stem(f0,abs(ap))
xlabel('Frequency (normalized)')
ylabel('Magnitude')
legend('B-SURE','True magnitudes')

